//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DarkGray
#property indicator_color2  DarkGray
#property indicator_color3  DarkGray
#property indicator_color4  Orange
#property indicator_width4  2
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT

//
//
//
//
//

extern int    RsiPeriod   = 14;
extern double FastEma     = 12;
extern double SlowEma     = 26;
extern int    Price       = PRICE_CLOSE;
extern int    MinMaxPeriod = 25;
extern int    overBought  = 70;
extern int    overSold    = 30;

double macd[];
double rsi[];
double bandu[];
double bandm[];
double bandd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,bandu);
   SetIndexBuffer(1,bandm);
   SetIndexBuffer(2,bandd);
   SetIndexBuffer(3,rsi);
   SetIndexBuffer(4,macd);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _fastEma 0
#define _slowEma 1

int start() 
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
         
         //
         //
         //
         //
         //
         

   double alphaF = 2.0/(1.0+FastEma);
   double alphaS = 2.0/(1.0+SlowEma);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         work[r][_fastEma] = work[r-1][_fastEma]+alphaF*(price-work[r-1][_fastEma]);
         work[r][_slowEma] = work[r-1][_slowEma]+alphaS*(price-work[r-1][_slowEma]);
         macd[i] = work[r][_fastEma]-work[r][_slowEma];
   }
   for(i=limit; i>=0; i--)
   {
      double min   = Low[ArrayMinimum(Low,MinMaxPeriod,i)];
      double max   = High[ArrayMaximum(High,MinMaxPeriod,i)];
      double range = max-min;
      double trsi  = iRSIOnArray(macd,0,RsiPeriod,i);
             bandm[i] = (max+min)/2;
             bandu[i] = (min+range*(overBought)/100);
             bandd[i] = (min+range*(overSold)/100);
             rsi[i]   = (min+range*(trsi)/100);      
   }             
   return(0);
}